pcl::MultiChannel2DComparisonFeatureHandler< DATA_TYPE, NUM_OF_CHANNELS > Class Template Reference

Feature utility class that handles the creation and evaluation of RGBD comparison features. More...

`#include <pcl/ml/multi_channel_2d_comparison_feature_handler.h>`

Inheritance diagram for pcl::MultiChannel2DComparisonFeatureHandler< DATA_TYPE, NUM_OF_CHANNELS >:

## Public Member Functions

| MultiChannel2DComparisonFeatureHandler (const int feature_window_width, const int feature_window_height)
| Constructor. More...
virtual | ~MultiChannel2DComparisonFeatureHandler ()
| Destructor. More...
void | setFeatureWindowSize (int width, int height)
| Sets the feature window size. More...
void | createRandomFeatures (const size_t num_of_features, std::vector< MultiChannel2DComparisonFeature< PointXY32i > > &features)
| Creates random features. More...
void | evaluateFeature (const MultiChannel2DComparisonFeature< PointXY32i > &feature, MultiChannel2DDataSet< DATA_TYPE, NUM_OF_CHANNELS > &data_set, std::vector< MultipleData2DExampleIndex > &examples, std::vector< float > &results, std::vector< unsigned char > &flags) const
| Evaluates a feature for a set of examples on the specified data set. More...
void | evaluateFeature (const MultiChannel2DComparisonFeature< PointXY32i > &feature, MultiChannel2DDataSet< DATA_TYPE, NUM_OF_CHANNELS > &data_set, const MultipleData2DExampleIndex &example, float &result, unsigned char &flag) const
| Evaluates a feature for one examples on the specified data set. More...
void | generateCodeForEvaluation (const MultiChannel2DComparisonFeature< PointXY32i > &feature, std::ostream &stream) const
| Generates code for feature evaluation. More...
Public Member Functions inherited from pcl::FeatureHandler< pcl::MultiChannel2DComparisonFeature< pcl::PointXY32i >, pcl::MultiChannel2DDataSet< DATA_TYPE, NUM_OF_CHANNELS >, pcl::MultipleData2DExampleIndex >
virtual | ~FeatureHandler ()
| Destructor. More...
virtual void | generateCodeForEvaluation (const pcl::MultiChannel2DComparisonFeature< pcl::PointXY32i > &feature, ::std::ostream &stream) const=0
| Generates evaluation code for the specified feature and writes it to the specified stream. More...

## Detailed Description

### template<class DATA_TYPE, size_t NUM_OF_CHANNELS>
class pcl::MultiChannel2DComparisonFeatureHandler< DATA_TYPE, NUM_OF_CHANNELS >

Feature utility class that handles the creation and evaluation of RGBD comparison features.

Definition at line 58 of file multi_channel_2d_comparison_feature_handler.h.

## Constructor & Destructor Documentation

## MultiChannel2DComparisonFeatureHandler()

template<class DATA_TYPE , size_t NUM_OF_CHANNELS>

pcl::MultiChannel2DComparisonFeatureHandler< DATA_TYPE, NUM_OF_CHANNELS >::MultiChannel2DComparisonFeatureHandler | ( | const int | feature_window_width,
|  | const int | feature_window_height
| ) |  |

inline

Constructor.

Definition at line 65 of file multi_channel_2d_comparison_feature_handler.h.

## ~MultiChannel2DComparisonFeatureHandler()

template<class DATA_TYPE , size_t NUM_OF_CHANNELS>

virtual pcl::MultiChannel2DComparisonFeatureHandler< DATA_TYPE, NUM_OF_CHANNELS >::~MultiChannel2DComparisonFeatureHandler | ( |  | ) |

inline virtual

Destructor.

Definition at line 71 of file multi_channel_2d_comparison_feature_handler.h.

## Member Function Documentation

## createRandomFeatures()

template<class DATA_TYPE , size_t NUM_OF_CHANNELS>

void pcl::MultiChannel2DComparisonFeatureHandler< DATA_TYPE, NUM_OF_CHANNELS >::createRandomFeatures | ( | const size_t | num_of_features,
|  | std::vector< MultiChannel2DComparisonFeature< PointXY32i > > & | features
| ) |  |

inline virtual

Creates random features.

Parameters

  [in] | num_of_features | The number of random features to create.
  [out] | features | The destination for the created random features.

Implements pcl::FeatureHandler< pcl::MultiChannel2DComparisonFeature< pcl::PointXY32i >, pcl::MultiChannel2DDataSet< DATA_TYPE, NUM_OF_CHANNELS >, pcl::MultipleData2DExampleIndex >.

Definition at line 91 of file multi_channel_2d_comparison_feature_handler.h.

References pcl::PointXY32i::randomPoint().

## evaluateFeature() [1/2]

template<class DATA_TYPE , size_t NUM_OF_CHANNELS>

void pcl::MultiChannel2DComparisonFeatureHandler< DATA_TYPE, NUM_OF_CHANNELS >::evaluateFeature | ( | const MultiChannel2DComparisonFeature< PointXY32i > & | feature,
|  | MultiChannel2DDataSet< DATA_TYPE, NUM_OF_CHANNELS > & | data_set,
|  | std::vector< MultipleData2DExampleIndex > & | examples,
|  | std::vector< float > & | results,
|  | std::vector< unsigned char > & | flags
| ) |  | const

inline virtual

Evaluates a feature for a set of examples on the specified data set.

Parameters

  [in] | feature | The feature to evaluate.
  [in] | data_set | The data set the feature is evaluated on.
  [in] | examples | The examples the feature is evaluated for.
  [out] | results | The destination for the evaluation results.
  [out] | flags | The destination for the flags corresponding to the evaluation results.

Implements pcl::FeatureHandler< pcl::MultiChannel2DComparisonFeature< pcl::PointXY32i >, pcl::MultiChannel2DDataSet< DATA_TYPE, NUM_OF_CHANNELS >, pcl::MultipleData2DExampleIndex >.

Definition at line 112 of file multi_channel_2d_comparison_feature_handler.h.

## evaluateFeature() [2/2]

template<class DATA_TYPE , size_t NUM_OF_CHANNELS>

void pcl::MultiChannel2DComparisonFeatureHandler< DATA_TYPE, NUM_OF_CHANNELS >::evaluateFeature | ( | const MultiChannel2DComparisonFeature< PointXY32i > & | feature,
|  | MultiChannel2DDataSet< DATA_TYPE, NUM_OF_CHANNELS > & | data_set,
|  | const MultipleData2DExampleIndex & | example,
|  | float & | result,
|  | unsigned char & | flag
| ) |  | const

inline virtual

Evaluates a feature for one examples on the specified data set.

Parameters

  [in] | feature | The feature to evaluate.
  [in] | data_set | The data set the feature is evaluated on.
  [in] | example | The example the feature is evaluated for.
  [out] | result | The destination for the evaluation result.
  [out] | flag | The destination for the flag corresponding to the evaluation result.

Implements pcl::FeatureHandler< pcl::MultiChannel2DComparisonFeature< pcl::PointXY32i >, pcl::MultiChannel2DDataSet< DATA_TYPE, NUM_OF_CHANNELS >, pcl::MultipleData2DExampleIndex >.

Definition at line 137 of file multi_channel_2d_comparison_feature_handler.h.

References pcl::MultiChannel2DComparisonFeature< PointT >::channel, pcl::MultipleData2DExampleIndex::data_set_id, pcl::MultiChannel2DComparisonFeature< PointT >::p1, pcl::MultiChannel2DComparisonFeature< PointT >::p2, pcl::MultipleData2DExampleIndex::x, and pcl::MultipleData2DExampleIndex::y.

## generateCodeForEvaluation()

template<class DATA_TYPE , size_t NUM_OF_CHANNELS>

void pcl::MultiChannel2DComparisonFeatureHandler< DATA_TYPE, NUM_OF_CHANNELS >::generateCodeForEvaluation | ( | const MultiChannel2DComparisonFeature< PointXY32i > & | feature,
|  | std::ostream & | stream
| ) |  | const

inline

Generates code for feature evaluation.

Parameters

  [in] | feature | The feature for which code is generated.
  [out] | stream | The destination for the generated code.

Definition at line 167 of file multi_channel_2d_comparison_feature_handler.h.

## setFeatureWindowSize()

template<class DATA_TYPE , size_t NUM_OF_CHANNELS>

void pcl::MultiChannel2DComparisonFeatureHandler< DATA_TYPE, NUM_OF_CHANNELS >::setFeatureWindowSize | ( | int | width,
|  | int | height
| ) |  |

inline

Sets the feature window size.

Parameters

  [in] | width | The width of the feature window.
  [in] | height | The height of the feature window.

Definition at line 78 of file multi_channel_2d_comparison_feature_handler.h.

The documentation for this class was generated from the following file:

- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/ml/include/pcl/ml/multi_channel_2d_comparison_feature_handler.h